<!DOCTYPE html>
<html>
<head>
	<title>PasteMess</title>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<link type="text/css" rel="stylesheet" href="./css/base.css"/>
	<script type="text/javascript" src="./scripts/index.js"></script>
</head>

<body>
	<h1>PasteMess<h1>
	<h3>by Thyrst'</h3>
	<br>
	<a href="http://thyrst.g6.cz/files/tools/pastemess.tar.gz">Get Source Code!</a>
	<br><br>

	<?php
		error_reporting(E_ERROR | E_PARSE | E_COMPILE_ERROR);
		if (isset($_POST["sent"]) && isset($_POST["text"])) {

			$content = htmlspecialchars($_POST["text"], ENT_QUOTES);
			$key = "";

			if (isset($_POST["key"])) {

				preg_match_all("/[[:alnum:]_]+/", $_POST["key"], $found);
				foreach ($found as $index => $array) {
					foreach ($array as $k => $value) {
						$key .= $value;
					}
				}

				if ($key != "") {
					$num = strlen($key);
					$hash = base64_encode($num);
					$hash .= hash('sha256',$key,TRUE);
					$code = base64_encode($hash);
					$initialization = mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_ECB);
					$iv = mcrypt_create_iv($initialization, MCRYPT_RAND); 
					$content = mcrypt_encrypt(MCRYPT_RIJNDAEL_256, $code, $content, MCRYPT_MODE_ECB, $iv);	
				}
			}
			
			preg_match("/[[:alnum:]]+/", $_POST["language"], $an);
			$filename = "$an[0]_";
			$filename .= md5(date("j M D G:i:s Y"));
			file_put_contents("./files/$filename", $content);
			echo 			"<br><a href=\"./view.php?file={$filename}\"><b>Your File</b></a><br>";
			if ($key) echo 	"<p>Decrypt key is: <b>{$key}</b></p><br>";
			echo 			"<br><br>";
		}
	?>

	<form name="data" action="<?php echo $_SERVER['PHP_SELF'] ?>" method="post">
		<input type="hidden" name="sent">
		<table align=center>
			<tr align=left>
				<td>
					<label for="key" accesskey="k"><b><u>K</u>ey:</b></label>
				</td>
				<td>
					<input type="text" placeholder="Key to encrypt your text" size=20 maxlength=30 id="key" name="key">
					<span style="font-size: 11px">(Only alphanumeric characters!)</span>
				</td>
			</tr>
			<tr>
				<td>
					<label for="text" accesskey="t"><b><u>T</u>ext:</b></label>
					</td>
				<td align=right>
					<select name="language">
						<option value="plain" <?php echo $_POST["language"]=="plain" ? "selected" : "" ?>>Plain Text</option>
						<option value="ac3" <?php echo $_POST["language"]=="as3" ? "selected" : "" ?>>ActionScript3</option>
						<option value="bash" <?php echo $_POST["language"]=="bash" ? "selected" : "" ?>>Bash/shell</option>
						<option value="cf" <?php echo $_POST["language"]=="cf" ? "selected" : "" ?>>ColdFusion</option>
						<option value="csharp" <?php echo $_POST["language"]=="csharp" ? "selected" : "" ?>>C#</option>
						<option value="cpp" <?php echo $_POST["language"]=="cpp" ? "selected" : "" ?>>C++</option>
						<option value="css" <?php echo $_POST["language"]=="css" ? "selected" : "" ?>>CSS</option>
						<option value="delphi" <?php echo $_POST["language"]=="delphi" ? "selected" : "" ?>>Delphi</option>
						<option value="diff" <?php echo $_POST["language"]=="diff" ? "selected" : "" ?>>Diff</option>
						<option value="erlang" <?php echo $_POST["language"]=="erlang" ? "selected" : "" ?>>Erlang</option>
						<option value="groovy" <?php echo $_POST["language"]=="groovy" ? "selected" : "" ?>>Groovy</option>
						<option value="js" <?php echo $_POST["language"]=="js" ? "selected" : "" ?>>JavaScript</option>
						<option value="java" <?php echo $_POST["language"]=="java" ? "selected" : "" ?>>Java</option>
						<option value="jfx" <?php echo $_POST["language"]=="jfx" ? "selected" : "" ?>>JavaFX</option>
						<option value="perl" <?php echo $_POST["language"]=="perl" ? "selected" : "" ?>>Perl</option>
						<option value="php" <?php echo $_POST["language"]=="php" ? "selected" : "" ?>>PHP</option>
						<option value="ps" <?php echo $_POST["language"]=="ps" ? "selected" : "" ?>>PowerShell</option>
						<option value="py" <?php echo $_POST["language"]=="py" ? "selected" : "" ?>>Python</option>
						<option value="ruby" <?php echo $_POST["language"]=="ruby" ? "selected" : "" ?>>Ruby</option>
						<option value="scala" <?php echo $_POST["language"]=="scala" ? "selected" : "" ?>>Scala</option>
						<option value="sql" <?php echo $_POST["language"]=="sql" ? "selected" : "" ?>>SQL</option>
						<option value="vb" <?php echo $_POST["language"]=="vb" ? "selected" : "" ?>>Visual Basic</option>
						<option value="html" <?php echo $_POST["language"]=="html" ? "selected" : "" ?>>XML/HTML</option>
					</select>
					<button type="submit" title="Save It!">
						<span style="font-size: 20px">
							<b>Save It!</b>
						</span>
					</button
				</td>
			</tr>
			<tr>
				<td></td>
				<td>
					<textarea name="text" cols=130 rows=30 maxlength=120000 wrap=off value="<?php echo $_POST["text"]; ?>" id="text"></textarea>
				</td>
			</tr>
		</table>
	</form>
	<div class="footer">
		<p>Copyleft <span id="copyleft">&copy;</span> Thyrst' 2013</p>
	</div>
</body>
</html>