<!DOCTYPE html>
<html>
<head>
	<title>PasteMess</title>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
	<link type="text/css" rel="stylesheet" href="./css/shCoreDefault.css"/>
	<link type="text/css" rel="stylesheet" href="./css/shCore.css"/>
	<link type="text/css" rel="stylesheet" href="./css/base.css"/>
	<script type="text/javascript" src="./scripts/view.js"></script>
	<script type="text/javascript" src="./scripts/shCore.js"></script>
	<script type="text/javascript" src="./scripts/shBrushAS3.js"></script>
	<script type="text/javascript" src="./scripts/shBrushBash.js"></script>
	<script type="text/javascript" src="./scripts/shBrushColdFusion.js"></script>
	<script type="text/javascript" src="./scripts/shBrushCSharp.js"></script>
	<script type="text/javascript" src="./scripts/shBrushCpp.js"></script>
	<script type="text/javascript" src="./scripts/shBrushCss.js"></script>
	<script type="text/javascript" src="./scripts/shBrushDelphi.js"></script>
	<script type="text/javascript" src="./scripts/shBrushDiff.js"></script>
	<script type="text/javascript" src="./scripts/shBrushErlang.js"></script>
	<script type="text/javascript" src="./scripts/shBrushGroovy.js"></script>
	<script type="text/javascript" src="./scripts/shBrushJScript.js"></script>
	<script type="text/javascript" src="./scripts/shBrushJava.js"></script>
	<script type="text/javascript" src="./scripts/shBrushJavaFX.js"></script>
	<script type="text/javascript" src="./scripts/shBrushPerl.js"></script>
	<script type="text/javascript" src="./scripts/shBrushPhp.js"></script>
	<script type="text/javascript" src="./scripts/shBrushPlain.js"></script>
	<script type="text/javascript" src="./scripts/shBrushPowerShell.js"></script>
	<script type="text/javascript" src="./scripts/shBrushPython.js"></script>
	<script type="text/javascript" src="./scripts/shBrushRuby.js"></script>
	<script type="text/javascript" src="./scripts/shBrushScala.js"></script>
	<script type="text/javascript" src="./scripts/shBrushSql.js"></script>
	<script type="text/javascript" src="./scripts/shBrushVb.js"></script>
	<script type="text/javascript" src="./scripts/shBrushXml.js"></script>
	<script type="text/javascript">SyntaxHighlighter.all();</script>
</head>

<body>
	<a href="./index.php"><p style="color:black; font-size: 20px"><b>PasteMess</b></p></a>
	<br><br>
	<form name="decrypt" action="<?php echo $_SERVER['PHP_SELF'] ?>" method="get">
		<input type="hidden" name="file" value="<?php echo $_GET["file"]?>">
		<label for="key" accesskey="k"><b><u>K</u>ey:</b></label>
		<input type="text" placeholder="Key to decrypt your text" size=20 maxlength=30 id="key" name="key">
		<input type="submit" value="Send">
	</form>
	<br>

	<?php
		error_reporting(E_ERROR | E_PARSE | E_COMPILE_ERROR);
		if($_GET["file"]) {

			preg_match("/[[:alnum:]_]+/", $_GET["file"], $found);
			$file = "./files/$found[0]";
			if (file_exists($file)) {

				preg_match("/[[:alnum:]]+_/", $found[0], $lang);
				$language = rtrim($lang[0], "_");

				$text = file_get_contents("./files/".$found[0]);
				$key = "";
	
			if (isset($_GET["key"])) {

				preg_match_all("/[[:alnum:]_]+/", $_GET["key"], $found);
				foreach ($found as $index => $array) {
					foreach ($array as $k => $value) {
						$key .= $value;
					}
				}

				if ($key != "") {
					$num = strlen($key);
					$hash = base64_encode($num);
					$hash .= hash('sha256',$key,TRUE);
					$code = base64_encode($hash);
					$initialization = mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_ECB);
					$iv = mcrypt_create_iv($initialization, MCRYPT_RAND); 
					$tmp = mcrypt_decrypt(MCRYPT_RIJNDAEL_256, $code, $text, MCRYPT_MODE_ECB, $iv); 
	   				$text = trim($tmp);
	   			}
	   		}

				echo "<div class=\"board\"><pre class=\"brush: {$language}\">{$text}</pre></div>";

			} else {
				echo "<p style=\"color: red\">File not found!<p><br>";
			}
		}
	?>
	
	<div class="footer">
		<p>Copyleft <span id="copyleft">&copy;</span> Thyrst' 2013</p>
	</div>
</body>
</html>